// Generated by CoffeeScript 1.3.1
(function() {

  jQuery(function() {
    var clearVal, setVal;
    if (!jQuery('<input placeholder="1" />')[0].placeholder) {
      setVal = function() {
        var $this;
        $this = jQuery(this);
        if (!$this.val()) {
          $this.val($this.attr('placeholder'));
          $this.addClass('p2p-placeholder');
        }
        return;
      };
      clearVal = function() {
        var $this;
        $this = jQuery(this);
        if ($this.hasClass('p2p-placeholder')) {
          $this.val('');
          $this.removeClass('p2p-placeholder');
        }
        return;
      };
      jQuery('.p2p-search input[placeholder]').each(setVal).focus(clearVal).blur(setVal);
    }
    return jQuery('.p2p-box').each(function() {
      var $connections, $createButton, $createInput, $metabox, $searchInput, $spinner, $viewAll, PostsTab, ajax_request, append_connection, clear_connections, create_connection, delete_connection, refresh_candidates, remove_row, row_ajax_request, searchTab, switch_to_tab;
      $metabox = jQuery(this);
      $connections = $metabox.find('.p2p-connections');
      $spinner = jQuery('<img>', {
        'src': P2PAdmin.spinner,
        'class': 'p2p-spinner'
      });
      ajax_request = function(data, callback, type) {
        var handler;
        if (type == null) {
          type = 'POST';
        }
        jQuery.extend(data, {
          action: 'p2p_box',
          nonce: P2PAdmin.nonce,
          p2p_type: $metabox.data('p2p_type'),
          direction: $metabox.data('direction'),
          from: jQuery('#post_ID').val(),
          s: searchTab.params.s,
          paged: searchTab.params.paged
        });
        handler = function(response) {
          try {
            response = jQuery.parseJSON(response);
            return callback(response);
          } catch (e) {
            return typeof console !== "undefined" && console !== null ? console.error('Malformed response', response) : void 0;
          }
        };
        return jQuery.ajax({
          type: type,
          url: ajaxurl,
          data: data,
          success: handler
        });
      };
      PostsTab = (function() {

        PostsTab.name = 'PostsTab';

        function PostsTab(selector) {
          var _this = this;
          this.tab = $metabox.find(selector);
          this.params = {
            subaction: 'search',
            s: ''
          };
          this.init_pagination_data();
          this.tab.delegate('.p2p-prev, .p2p-next', 'click', function(ev) {
            return _this.change_page(ev.target);
          });
        }

        PostsTab.prototype.init_pagination_data = function() {
          this.params.paged = this.tab.find('.p2p-current').data('num') || 1;
          return this.total_pages = this.tab.find('.p2p-total').data('num') || 1;
        };

        PostsTab.prototype.change_page = function(button) {
          var $navButton, new_page;
          $navButton = jQuery(button);
          new_page = this.params.paged;
          if ($navButton.hasClass('inactive')) {
            return;
          }
          if ($navButton.hasClass('p2p-prev')) {
            new_page--;
          } else {
            new_page++;
          }
          $spinner.appendTo(this.tab.find('.p2p-navigation'));
          return this.find_posts(new_page);
        };

        PostsTab.prototype.find_posts = function(new_page) {
          var _this = this;
          if ((0 < new_page && new_page <= this.total_pages)) {
            this.params.paged = new_page;
          }
          return ajax_request(this.params, function(response) {
            return _this.update_rows(response);
          }, 'GET');
        };

        PostsTab.prototype.update_rows = function(response) {
          $spinner.remove();
          this.tab.find('button, .p2p-results, .p2p-navigation, .p2p-notice').remove();
          if (!response.rows) {
            return this.tab.append(jQuery('<div class="p2p-notice">').html(response.msg));
          } else {
            this.tab.append(response.rows);
            return this.init_pagination_data();
          }
        };

        return PostsTab;

      })();
      searchTab = new PostsTab('.p2p-tab-search');
      row_ajax_request = function($td, data, callback) {
        $td.html($spinner.show());
        return ajax_request(data, callback);
      };
      remove_row = function($td) {
        var $table;
        $table = $td.closest('table');
        $td.closest('tr').remove();
        if (!$table.find('tbody tr').length) {
          return $table.hide();
        }
      };
      append_connection = function(response) {
        $connections.show().find('tbody').append(response.row);
        if ('one' === $metabox.data('cardinality')) {
          return $metabox.find('.p2p-create-connections').hide();
        }
      };
      refresh_candidates = function(results) {
        $metabox.find('.p2p-create-connections').show();
        return searchTab.update_rows(results);
      };
      clear_connections = function(ev) {
        var $self, $td, data,
          _this = this;
        if (!confirm(P2PAdmin.deleteConfirmMessage)) {
          return false;
        }
        $self = jQuery(ev.target);
        $td = $self.closest('td');
        data = {
          subaction: 'clear_connections'
        };
        row_ajax_request($td, data, function(response) {
          $connections.hide().find('tbody').html('');
          $td.html($self);
          return refresh_candidates(response);
        });
        return false;
      };
      delete_connection = function(ev) {
        var $self, $td, data,
          _this = this;
        $self = jQuery(ev.target);
        $td = $self.closest('td');
        data = {
          subaction: 'disconnect',
          p2p_id: $self.closest('td').find('input').val()
        };
        row_ajax_request($td, data, function(response) {
          remove_row($td);
          return refresh_candidates(response);
        });
        return false;
      };
      create_connection = function(ev) {
        var $self, $td, data,
          _this = this;
        $self = jQuery(ev.target);
        $td = $self.closest('td');
        data = {
          subaction: 'connect',
          to: $self.data('post_id')
        };
        row_ajax_request($td, data, function(response) {
          append_connection(response);
          if ($metabox.data('duplicate_connections')) {
            return $td.html($self);
          } else {
            return remove_row($td);
          }
        });
        return false;
      };
      switch_to_tab = function() {
        var $tab;
        $tab = jQuery(this);
        $metabox.find('.wp-tab-bar li').removeClass('wp-tab-active');
        $tab.addClass('wp-tab-active');
        $metabox.find('.tabs-panel').hide().end().find($tab.data('ref')).show().find(':text').focus();
        return false;
      };
      $metabox.delegate('th.p2p-col-delete a', 'click', clear_connections).delegate('td.p2p-col-delete a', 'click', delete_connection).delegate('td.p2p-col-create a', 'click', create_connection).delegate('.wp-tab-bar li', 'click', switch_to_tab);
      if ($connections.find('th.p2p-col-order').length) {
        $connections.find('tbody').sortable({
          handle: 'td.p2p-col-order',
          helper: function(e, ui) {
            ui.children().each(function() {
              var $this;
              $this = jQuery(this);
              return $this.width($this.width());
            });
            return ui;
          }
        });
      }
      $viewAll = $metabox.find('.p2p-tab-search button');
      $viewAll.click(function() {
        searchTab.find_posts(1);
        return false;
      });
      $searchInput = $metabox.find('.p2p-tab-search :text');
      $searchInput.keypress(function(ev) {
        if (ev.keyCode === 13) {
          return false;
        }
      }).keyup(function(ev) {
        var delayed;
        if (delayed !== void 0) {
          clearTimeout(delayed);
        }
        return delayed = setTimeout(function() {
          var searchStr;
          searchStr = $searchInput.val();
          if (searchStr === searchTab.params.s) {
            return;
          }
          searchTab.params.s = searchStr;
          $spinner.insertAfter($searchInput).show();
          return searchTab.find_posts(1);
        }, 400);
      });
      $createButton = $metabox.find('.p2p-tab-create-post button');
      $createInput = $metabox.find('.p2p-tab-create-post :text');
      $createButton.click(function() {
        var $button, data, title;
        $button = jQuery(this);
        if ($button.hasClass('inactive')) {
          return false;
        }
        title = $createInput.val();
        if (title === '') {
          $createInput.focus();
          return false;
        }
        $button.addClass('inactive');
        data = {
          subaction: 'create_post',
          post_title: title
        };
        ajax_request(data, function(response) {
          append_connection(response);
          $createInput.val('');
          return $button.removeClass('inactive');
        });
        return false;
      });
      return $createInput.keypress(function(ev) {
        if (13 === ev.keyCode) {
          $createButton.click();
          return false;
        }
      });
    });
  });

}).call(this);
